//=============================================================================
//
// file :         PseudoAxisClass.h
//
// description :  Include for the PseudoAxisClass root class.
//                This class is represents the singleton class for
//                the PseudoAxis device class.
//                It contains all properties and methods which the 
//                PseudoAxis requires only once e.g. the commands.
//			
// project :      TANGO Device Server
//
// $Author: piccaf $
//
// $Revision: 1.3 $
//
// $Log: PseudoAxisClass.h,v $
// Revision 1.3  2008/09/24 08:37:48  piccaf
// * add dummy commandes for the Axis V2 interface
//
// Revision 1.2  2008/09/22 08:46:40  piccaf
// * add files from the new diffractometer Device
//
// Revision 1.3  2007/07/11 07:19:27  picca
// * add the "offset" and the "relativeMove" attributes  to the PseudoAxes.
// * syntax in Kappa6C
//
// Revision 1.2  2007/05/15 08:26:58  hardion
// * Merge with branch DIFFRACTO_KAPPA_6C
//
// Revision 1.1.2.1  2006/08/25 15:08:22  hardion
// * Merge corrections of hubert
// * Create directory for each class of device
// * Fix problem when PseudoAxis is initialized on first
// * Tested on diffabs for the communication part
//
// Revision 1.2  2006/07/06 10:29:44  hardion
// * commit to keep modification about Pseudo axis management but it doesn't work ( Error Check the wavelength)
// try to come back to old version to see if the problem persists
//
// Revision 1.1  2006/03/29 16:45:47  hardion
// * Add PseudoAxis device
// * Add DiffractometerFactory which associates Diffracto and PseudoAxis
//
//
// copyleft :     European Synchrotron Radiation Facility
//                BP 220, Grenoble 38043
//                FRANCE
//
//=============================================================================
//
//  		This file is generated by POGO
//	(Program Obviously used to Generate tango Object)
//
//         (c) - Software Engineering Group - ESRF
//=============================================================================

#ifndef _PSEUDOAXISCLASS_H
#define _PSEUDOAXISCLASS_H

#include <tango.h>
#include <PseudoAxis.h>


namespace PseudoAxis_ns
{
//=====================================
//	Define classes for attributes
//=====================================
class modeNamesAttrib: public Tango::SpectrumAttr
{
public:
	modeNamesAttrib():SpectrumAttr("modeNames", Tango::DEV_STRING, Tango::READ, 100) {};
	~modeNamesAttrib() {};
	
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
	{(static_cast<PseudoAxis *>(dev))->read_modeNames(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
	{return (static_cast<PseudoAxis *>(dev))->is_modeNames_allowed(ty);}
};

class IsInitialisedAttrib: public Tango::Attr
{
public:
	IsInitialisedAttrib():Attr("IsInitialised", Tango::DEV_BOOLEAN, Tango::READ_WRITE) {};
	~IsInitialisedAttrib() {};
	
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
	{(static_cast<PseudoAxis *>(dev))->read_IsInitialised(att);}
	virtual void write(Tango::DeviceImpl *dev,Tango::WAttribute &att)
	{(static_cast<PseudoAxis *>(dev))->write_IsInitialised(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
	{return (static_cast<PseudoAxis *>(dev))->is_IsInitialised_allowed(ty);}
};

class modeAttrib: public Tango::Attr
{
public:
	modeAttrib():Attr("mode", Tango::DEV_STRING, Tango::READ_WRITE) {};
	~modeAttrib() {};
	
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
	{(static_cast<PseudoAxis *>(dev))->read_mode(att);}
	virtual void write(Tango::DeviceImpl *dev,Tango::WAttribute &att)
	{(static_cast<PseudoAxis *>(dev))->write_mode(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
	{return (static_cast<PseudoAxis *>(dev))->is_mode_allowed(ty);}
};

class relativeMoveAttrib: public Tango::Attr
{
public:
	relativeMoveAttrib():Attr("relativeMove", Tango::DEV_DOUBLE, Tango::WRITE) {};
	~relativeMoveAttrib() {};
	
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
	{(static_cast<PseudoAxis *>(dev))->read_relativeMove(att);}
	virtual void write(Tango::DeviceImpl *dev,Tango::WAttribute &att)
	{(static_cast<PseudoAxis *>(dev))->write_relativeMove(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
	{return (static_cast<PseudoAxis *>(dev))->is_relativeMove_allowed(ty);}
};

class initializedAttrib: public Tango::Attr
{
public:
	initializedAttrib():Attr("initialized", Tango::DEV_BOOLEAN, Tango::READ_WRITE) {};
	~initializedAttrib() {};
	
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
	{(static_cast<PseudoAxis *>(dev))->read_initialized(att);}
	virtual void write(Tango::DeviceImpl *dev,Tango::WAttribute &att)
	{(static_cast<PseudoAxis *>(dev))->write_initialized(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
	{return (static_cast<PseudoAxis *>(dev))->is_initialized_allowed(ty);}
};

class offsetAttrib: public Tango::Attr
{
public:
	offsetAttrib():Attr("offset", Tango::DEV_DOUBLE, Tango::READ_WRITE) {};
	~offsetAttrib() {};
	
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
	{(static_cast<PseudoAxis *>(dev))->read_offset(att);}
	virtual void write(Tango::DeviceImpl *dev,Tango::WAttribute &att)
	{(static_cast<PseudoAxis *>(dev))->write_offset(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
	{return (static_cast<PseudoAxis *>(dev))->is_offset_allowed(ty);}
};

class positionAttrib: public Tango::Attr
{
public:
	positionAttrib():Attr("position", Tango::DEV_DOUBLE, Tango::READ_WRITE) {};
	~positionAttrib() {};
	
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
	{(static_cast<PseudoAxis *>(dev))->read_position(att);}
	virtual void write(Tango::DeviceImpl *dev,Tango::WAttribute &att)
	{(static_cast<PseudoAxis *>(dev))->write_position(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
	{return (static_cast<PseudoAxis *>(dev))->is_position_allowed(ty);}
};

//=========================================
//	Define classes for commands
//=========================================
class SetModeParametersClass : public Tango::Command
{
public:
	SetModeParametersClass(const char   *name,
	               Tango::CmdArgType in,
				   Tango::CmdArgType out,
				   const char        *in_desc,
				   const char        *out_desc,
				   Tango::DispLevel  level)
	:Command(name,in,out,in_desc,out_desc, level)	{};

	SetModeParametersClass(const char   *name,
	               Tango::CmdArgType in,
				   Tango::CmdArgType out)
	:Command(name,in,out)	{};
	~SetModeParametersClass() {};
	
	virtual CORBA::Any *execute (Tango::DeviceImpl *dev, const CORBA::Any &any);
	virtual bool is_allowed (Tango::DeviceImpl *dev, const CORBA::Any &any)
	{return (static_cast<PseudoAxis *>(dev))->is_SetModeParameters_allowed(any);}
};



class GetModeParametersClass : public Tango::Command
{
public:
	GetModeParametersClass(const char   *name,
	               Tango::CmdArgType in,
				   Tango::CmdArgType out,
				   const char        *in_desc,
				   const char        *out_desc,
				   Tango::DispLevel  level)
	:Command(name,in,out,in_desc,out_desc, level)	{};

	GetModeParametersClass(const char   *name,
	               Tango::CmdArgType in,
				   Tango::CmdArgType out)
	:Command(name,in,out)	{};
	~GetModeParametersClass() {};
	
	virtual CORBA::Any *execute (Tango::DeviceImpl *dev, const CORBA::Any &any);
	virtual bool is_allowed (Tango::DeviceImpl *dev, const CORBA::Any &any)
	{return (static_cast<PseudoAxis *>(dev))->is_GetModeParameters_allowed(any);}
};



class InitializeReferencePositionCmd : public Tango::Command
{
public:
	InitializeReferencePositionCmd(const char   *name,
	               Tango::CmdArgType in,
				   Tango::CmdArgType out,
				   const char        *in_desc,
				   const char        *out_desc,
				   Tango::DispLevel  level)
	:Command(name,in,out,in_desc,out_desc, level)	{};

	InitializeReferencePositionCmd(const char   *name,
	               Tango::CmdArgType in,
				   Tango::CmdArgType out)
	:Command(name,in,out)	{};
	~InitializeReferencePositionCmd() {};
	
	virtual CORBA::Any *execute (Tango::DeviceImpl *dev, const CORBA::Any &any);
	virtual bool is_allowed (Tango::DeviceImpl *dev, const CORBA::Any &any)
	{return (static_cast<PseudoAxis *>(dev))->is_InitializeReferencePosition_allowed(any);}
};



class DefinePositionCmd : public Tango::Command
{
public:
	DefinePositionCmd(const char   *name,
	               Tango::CmdArgType in,
				   Tango::CmdArgType out,
				   const char        *in_desc,
				   const char        *out_desc,
				   Tango::DispLevel  level)
	:Command(name,in,out,in_desc,out_desc, level)	{};

	DefinePositionCmd(const char   *name,
	               Tango::CmdArgType in,
				   Tango::CmdArgType out)
	:Command(name,in,out)	{};
	~DefinePositionCmd() {};
	
	virtual CORBA::Any *execute (Tango::DeviceImpl *dev, const CORBA::Any &any);
	virtual bool is_allowed (Tango::DeviceImpl *dev, const CORBA::Any &any)
	{return (static_cast<PseudoAxis *>(dev))->is_DefinePosition_allowed(any);}
};



class ForwardCmd : public Tango::Command
{
public:
	ForwardCmd(const char   *name,
	               Tango::CmdArgType in,
				   Tango::CmdArgType out,
				   const char        *in_desc,
				   const char        *out_desc,
				   Tango::DispLevel  level)
	:Command(name,in,out,in_desc,out_desc, level)	{};

	ForwardCmd(const char   *name,
	               Tango::CmdArgType in,
				   Tango::CmdArgType out)
	:Command(name,in,out)	{};
	~ForwardCmd() {};
	
	virtual CORBA::Any *execute (Tango::DeviceImpl *dev, const CORBA::Any &any);
	virtual bool is_allowed (Tango::DeviceImpl *dev, const CORBA::Any &any)
	{return (static_cast<PseudoAxis *>(dev))->is_Forward_allowed(any);}
};



class BackwardClass : public Tango::Command
{
public:
	BackwardClass(const char   *name,
	               Tango::CmdArgType in,
				   Tango::CmdArgType out,
				   const char        *in_desc,
				   const char        *out_desc,
				   Tango::DispLevel  level)
	:Command(name,in,out,in_desc,out_desc, level)	{};

	BackwardClass(const char   *name,
	               Tango::CmdArgType in,
				   Tango::CmdArgType out)
	:Command(name,in,out)	{};
	~BackwardClass() {};
	
	virtual CORBA::Any *execute (Tango::DeviceImpl *dev, const CORBA::Any &any);
	virtual bool is_allowed (Tango::DeviceImpl *dev, const CORBA::Any &any)
	{return (static_cast<PseudoAxis *>(dev))->is_Backward_allowed(any);}
};



class ComputeNewOffsetCmd : public Tango::Command
{
public:
	ComputeNewOffsetCmd(const char   *name,
	               Tango::CmdArgType in,
				   Tango::CmdArgType out,
				   const char        *in_desc,
				   const char        *out_desc,
				   Tango::DispLevel  level)
	:Command(name,in,out,in_desc,out_desc, level)	{};

	ComputeNewOffsetCmd(const char   *name,
	               Tango::CmdArgType in,
				   Tango::CmdArgType out)
	:Command(name,in,out)	{};
	~ComputeNewOffsetCmd() {};
	
	virtual CORBA::Any *execute (Tango::DeviceImpl *dev, const CORBA::Any &any);
	virtual bool is_allowed (Tango::DeviceImpl *dev, const CORBA::Any &any)
	{return (static_cast<PseudoAxis *>(dev))->is_ComputeNewOffset_allowed(any);}
};



class MotorInitCmd : public Tango::Command
{
public:
	MotorInitCmd(const char   *name,
	               Tango::CmdArgType in,
				   Tango::CmdArgType out,
				   const char        *in_desc,
				   const char        *out_desc,
				   Tango::DispLevel  level)
	:Command(name,in,out,in_desc,out_desc, level)	{};

	MotorInitCmd(const char   *name,
	               Tango::CmdArgType in,
				   Tango::CmdArgType out)
	:Command(name,in,out)	{};
	~MotorInitCmd() {};
	
	virtual CORBA::Any *execute (Tango::DeviceImpl *dev, const CORBA::Any &any);
	virtual bool is_allowed (Tango::DeviceImpl *dev, const CORBA::Any &any)
	{return (static_cast<PseudoAxis *>(dev))->is_MotorInit_allowed(any);}
};



class MotorONCmd : public Tango::Command
{
public:
	MotorONCmd(const char   *name,
	               Tango::CmdArgType in,
				   Tango::CmdArgType out,
				   const char        *in_desc,
				   const char        *out_desc,
				   Tango::DispLevel  level)
	:Command(name,in,out,in_desc,out_desc, level)	{};

	MotorONCmd(const char   *name,
	               Tango::CmdArgType in,
				   Tango::CmdArgType out)
	:Command(name,in,out)	{};
	~MotorONCmd() {};
	
	virtual CORBA::Any *execute (Tango::DeviceImpl *dev, const CORBA::Any &any);
	virtual bool is_allowed (Tango::DeviceImpl *dev, const CORBA::Any &any)
	{return (static_cast<PseudoAxis *>(dev))->is_MotorON_allowed(any);}
};



class MotorOFFCmd : public Tango::Command
{
public:
	MotorOFFCmd(const char   *name,
	               Tango::CmdArgType in,
				   Tango::CmdArgType out,
				   const char        *in_desc,
				   const char        *out_desc,
				   Tango::DispLevel  level)
	:Command(name,in,out,in_desc,out_desc, level)	{};

	MotorOFFCmd(const char   *name,
	               Tango::CmdArgType in,
				   Tango::CmdArgType out)
	:Command(name,in,out)	{};
	~MotorOFFCmd() {};
	
	virtual CORBA::Any *execute (Tango::DeviceImpl *dev, const CORBA::Any &any);
	virtual bool is_allowed (Tango::DeviceImpl *dev, const CORBA::Any &any)
	{return (static_cast<PseudoAxis *>(dev))->is_MotorOFF_allowed(any);}
};



class OnCmd : public Tango::Command
{
public:
	OnCmd(const char   *name,
	               Tango::CmdArgType in,
				   Tango::CmdArgType out,
				   const char        *in_desc,
				   const char        *out_desc,
				   Tango::DispLevel  level)
	:Command(name,in,out,in_desc,out_desc, level)	{};

	OnCmd(const char   *name,
	               Tango::CmdArgType in,
				   Tango::CmdArgType out)
	:Command(name,in,out)	{};
	~OnCmd() {};
	
	virtual CORBA::Any *execute (Tango::DeviceImpl *dev, const CORBA::Any &any);
	virtual bool is_allowed (Tango::DeviceImpl *dev, const CORBA::Any &any)
	{return (static_cast<PseudoAxis *>(dev))->is_On_allowed(any);}
};



class StopCmd : public Tango::Command
{
public:
	StopCmd(const char   *name,
	               Tango::CmdArgType in,
				   Tango::CmdArgType out,
				   const char        *in_desc,
				   const char        *out_desc,
				   Tango::DispLevel  level)
	:Command(name,in,out,in_desc,out_desc, level)	{};

	StopCmd(const char   *name,
	               Tango::CmdArgType in,
				   Tango::CmdArgType out)
	:Command(name,in,out)	{};
	~StopCmd() {};
	
	virtual CORBA::Any *execute (Tango::DeviceImpl *dev, const CORBA::Any &any);
	virtual bool is_allowed (Tango::DeviceImpl *dev, const CORBA::Any &any)
	{return (static_cast<PseudoAxis *>(dev))->is_Stop_allowed(any);}
};



//
// The PseudoAxisClass singleton definition
//

class PseudoAxisClass : public Tango::DeviceClass
{
public:
//	properties member data

//	add your own data members here
//------------------------------------

public:
	Tango::DbData	cl_prop;
	Tango::DbData	cl_def_prop;
	Tango::DbData	dev_def_prop;

//	Method prototypes
	static PseudoAxisClass *init(const char *);
	static PseudoAxisClass *instance();
	~PseudoAxisClass();
	Tango::DbDatum	get_class_property(string &);
	Tango::DbDatum	get_default_device_property(string &);
	Tango::DbDatum	get_default_class_property(string &);
	
protected:
	PseudoAxisClass(string &);
	static PseudoAxisClass *_instance;
	void command_factory();
	void get_class_property();
	void attribute_factory(vector<Tango::Attr *> &);
	void write_class_property();
	void set_default_property();

private:
	void device_factory(const Tango::DevVarStringArray *);
};


}	//	namespace PseudoAxis_ns

#endif // _PSEUDOAXISCLASS_H
